set docdir ./doc/html

set extensions {
  idl
  h
  htm
}

proc findFile {pattern {directory .} {recursive no} {fullpath no}} {
  set filelist {}
  set pwd [pwd]

  if [catch {cd $directory} err] {
    return
  }

  foreach match [eval glob -nocomplain -- $pattern] {
    if {$fullpath} {
      lappend filelist [file join $directory $match]
    } else {
      lappend filelist $match
    }
  }

  if {$recursive} {
    foreach file [glob -nocomplain *] {
      if [file isdirectory $file] {
        set filelist [concat $filelist [findFile [file join $directory $file] $pattern $recursive $fullpath]]
      }
    }
  }

  cd $pwd

  set filelist
}

proc fixDocFile {file extensions} {
  set ofile [open $file r]
  set data [read $ofile]
  close $ofile

  set pattern "\\.(([join $extensions "|"])(#\[^.\]*)?)\\.html"
  regsub -all $pattern $data {.\1} result

  set ofile [open $file w]
  puts $ofile $result
  close $ofile
}

foreach file [findFile *.html $docdir no yes] {
  puts "Fixing $file"
  fixDocFile $file $extensions
}
