package require tclxpcom

proc echo {value} {
  return $value
}

proc newConsoleMessage {string} {
   set bindings(message) [list echo $string]
   set result [xpcom::wrap nsIConsoleMessage [array get bindings]]
   $result QueryInterface nsIConsoleMessage
}

proc testConsoleService {cservice} {
  $cservice logMessage [newConsoleMessage "This is a log"]
  $cservice logStringMessage "This is the first log"
  $cservice logStringMessage "And this is the second"
  $cservice getMessageArray messages

  foreach message $messages {
    puts [$message set message]
  }
}

proc dumpOutParams {} {
  parray xpcom::outparams
}

namespace eval ::cservice {
  variable messages

  proc logMessage {nsIConsoleMessage} {
    variable messages
    lappend messages $nsIConsoleMessage
  }

  proc logStringMessage {wstring} {
    variable messages
    lappend messages [newConsoleMessage $wstring]
  }

  proc getMessageArray {list_nsIConsoleMessage_out} {
    variable messages
    upvar $list_nsIConsoleMessage_out list_nsIConsoleMessage
    dumpOutParams
    set list_nsIConsoleMessage $messages
    dumpOutParams
  }

  proc registerListener {nsIConsoleListener} {
    xpcom::throw $xpcom::NS_ERROR_NOT_IMPLEMENTED
  }

  proc unregisterListener {nsIConsoleListener} {
    xpcom::throw $xpcom::NS_ERROR_NOT_IMPLEMENTED
  }
}

### test mozilla's consoleservice
set cservice [xpcom::new "@mozilla.org/consoleservice;1" nsIConsoleService]
testConsoleService $cservice

### test our implementation of nsIConsoleService
set cservice [xpcom::wrap {nsIConsoleService} [xpcom::bindings {nsIConsoleService} ::cservice]]
testConsoleService [$cservice QueryInterface nsIConsoleService]
