package require tclxpcom

set ds [xpcom::new -service "@mozilla.org/file/directory_service;1" nsIProperties]

proc getProperty {property} {
  global ds

  if {[catch {set file [$ds get $property nsIFile]} result]} {
    return ""
  } else {
    return [$file set path]
  }
}

### Property strings copied from nsDirectoryPrefs.h
### and nsAppDirectoryServiceDefs.h
set properties {
  "MozBinD" "XCurProcD" "ComRegF" "ComsD"
  "Home" "DrvD" "TmpD" "CurProcD" "CurWorkD"
  "SysD"
  "Desk" "Trsh" "Strt" "Shdwn" "ApplMenu" "CntlPnl" "Exts"
  "Fnts" "Prfs" "Docs" "ISrch" "Home" "DfltDwnld" "ULibDir"
  "WinD" "Home" "DeskV" "Progs" "Cntls" "Prnts" "Pers" "Favs"
  "Strt" "Rcnt" "SndTo" "Buckt" "Strt" "DeskP" "Drivs" "NetW"
  "netH" "Fnts" "Tmpls" "CmStrt" "CmPrgs" "CmStrt" "CmDeskP"
  "AppData" "PrntHd" "Locl" "LibD" "Home" "OS2Dir" "Home"
  "Desk" "Setngs" "Home" "Desk"

  "AppRegF" "AppRegD" "DefRt" "PrfDef" "profDef"
  "ProfDefNoLoc" "DefProfRt" "ARes" "AChrom" "APlugns" "SrchPlugns"

  "PrefD" "PrefF" "ProfD" "UChrm" "LclSt" "UHist"
  "UPnls" "UMimTyp" "BMarks" "SrchF" "MailD" "IMapMD"
  "NewsD" "MFCaD"
}

foreach property $properties {
  puts [format "%-20s%s" "Property: $property" "Path: [getProperty $property]"]
}
