package require tclxpcom

proc iinfo {interface} {
  foreach attribute [xpcom::info attributes $interface] {
    puts "$interface.$attribute [xpcom::info type $interface $attribute]"
  }
  foreach method [xpcom::info methods $interface] {
    puts "$interface.$method [xpcom::info args $interface $method] returns [xpcom::info retval $interface $method]"
  }
}

proc dumpinterfaces {} {
  set ofile [open "interfaces.txt" w]

  foreach interface [xpcom::interfaces] {

    puts $ofile "Interface: $interface"

    foreach attribute [xpcom::info attributes $interface] {
      puts $ofile "  Attribute: $attribute Type: [xpcom::info type $interface $attribute]"
    }

    foreach method [xpcom::info methods $interface] {
      puts $ofile "  Method: $method Retval: [xpcom::info retval $interface $method] Args: [xpcom::info args $interface $method]"
    }
  }

  close $ofile
}

proc prototypeall {} {
  xpcom::prototype [xpcom::interfaces] ::all
}

proc dumpprototype {} {
  set ofile [open "prototypes.txt" w]
  puts $ofile [prototypeall]
  close $ofile
}
