package require tclxpcom

proc getProperty {property} {
  global ds

  if {[catch {set file [$ds get $property nsIFile]} result]} {
    return ""
  } else {
    return [$file set path]
  }
}

proc findFile {pattern {directory .} {recursive no} {fullpath no}} {
  set filelist ""
  set pwd [pwd]

  if [catch {cd $directory} err] {
    return
  }

  foreach match [eval glob -nocomplain -- $pattern] {
    if {$fullpath} {
      lappend filelist [file join $directory $match]
    } else {
      lappend filelist $match
    }
  }

  if {$recursive} {
    foreach file [glob -nocomplain *] {
      if [file isdirectory $file] {
        set filelist [concat $filelist [findFile [file join $directory $file] $pattern $recursive $fullpath]]
      }
    }
  }

  cd $pwd
  return $filelist
}

set ds [xpcom::new -service "@mozilla.org/file/directory_service;1" nsIProperties]
set compdir [getProperty "ComsD"]
set outputdir [file join [pwd] typelibs]

file mkdir $outputdir

foreach file [findFile *.xpt $compdir no yes] {
  puts $file
  exec xpt_dump $file > [file join $outputdir [file rootname [file tail $file]].txt]
  exec xpt_dump -v $file > [file join $outputdir [file rootname [file tail $file]]_v.txt]
}
