@echo off

rem #####################################################
rem ##
rem ##   Win32 Installation Script for TclXPCOM
rem ## 
rem ##   Adjust the following values according to your
rem ##   configuration before running
rem ##   Set DEBUG to 0 if you don't want to install
rem ##   the debug version
rem ##
rem #####################################################

set DEBUG=1
set TCL_HOME=c:\progra~1\tcl
set MOZILLA_HOME=c:\mozilla\mozilla\dist\win32_o.obj\bin
set MOZILLA_HOME_DEBUG=c:\mozilla\mozilla\dist\win32_d.obj\bin

rem #####################################################
rem ## End of User-definable section
rem #####################################################

set VERSION=0.1
set LIBNAME_RELEASE=TclXPCOM.dll
set LIBNAME_DEBUG=TclXPCOMd.dll
set LOADER_LIBNAME_RELEASE=tclxpcom_loader.dll
set LOADER_LIBNAME_DEBUG=tclxpcom_loaderd.dll

set REGXPCOM=%MOZILLA_HOME%\regxpcom
set REGXPCOM_DEBUG=%MOZILLA_HOME_DEBUG%\regxpcom
set COMPONENT_DIR=%MOZILLA_HOME%\components
set COMPONENT_DIR_DEBUG=%MOZILLA_HOME_DEBUG%\components
set PACKAGE_DIR=%TCL_HOME%\lib\tclxpcom%VERSION%
set PACKAGE_INDEX=%PACKAGE_DIR%\pkgIndex.tcl

set LIBRARIES=.\Release\%LIBNAME_RELEASE%
set SCRIPTS=.\scripts\tclxpcom.tcl .\scripts\tclxpcom_loader.tcl
set HEADERS=.\include\tclxpcom.h

if %DEBUG%==1 set LIBRARIES=%LIBRARIES% .\Debug\%LIBNAME_DEBUG%

echo Installing headers to %TCL_HOME%\include
for %%i in (%HEADERS%) do copy %%i %TCL_HOME%\include

echo Creating %PACKAGE_DIR%
mkdir %PACKAGE_DIR%

echo Installing libraries to %PACKAGE_DIR%
for %%i in (%LIBRARIES%) do copy %%i %PACKAGE_DIR%

echo Installing scripts to %PACKAGE_DIR%
for %%i in (%SCRIPTS%) do copy %%i %PACKAGE_DIR%

echo Generating pkgIndex.tcl in %PACKAGE_DIR%...

echo if {[info exists tcl_platform(debug)]} {                                                        > %PACKAGE_INDEX%
echo     package ifneeded tclxpcom %VERSION% "                                                      >> %PACKAGE_INDEX%
echo       namespace eval xpcom {}                                                                  >> %PACKAGE_INDEX%
echo       set ::xpcom::mozilla_home \[file nativename [list {%MOZILLA_HOME_DEBUG%}]\]              >> %PACKAGE_INDEX%
echo       set env(path) \"\$::xpcom::mozilla_home;\$env(path)\"                                    >> %PACKAGE_INDEX%
echo       load [list [file join $dir %LIBNAME_DEBUG%]] tclxpcom                                    >> %PACKAGE_INDEX%
echo       source [list [file join $dir tclxpcom.tcl]]                                              >> %PACKAGE_INDEX%
echo     "                                                                                          >> %PACKAGE_INDEX%
echo } else {                                                                                       >> %PACKAGE_INDEX%
echo     package ifneeded tclxpcom %VERSION% "                                                      >> %PACKAGE_INDEX%
echo       namespace eval xpcom {}                                                                  >> %PACKAGE_INDEX%
echo       set ::xpcom::mozilla_home \[file nativename [list {%MOZILLA_HOME%}]\]                    >> %PACKAGE_INDEX%
echo       set env(path) \"\$::xpcom::mozilla_home;\$env(path)\"                                    >> %PACKAGE_INDEX%
echo       load [list [file join $dir %LIBNAME_RELEASE%]] tclxpcom                                  >> %PACKAGE_INDEX%
echo       source [list [file join $dir tclxpcom.tcl]]                                              >> %PACKAGE_INDEX%
echo     "                                                                                          >> %PACKAGE_INDEX%
echo }                                                                                              >> %PACKAGE_INDEX%
echo package ifneeded tclxpcom_loader %VERSION% [list source [file join $dir tclxpcom_loader.tcl]]  >> %PACKAGE_INDEX%

echo Installing %LOADER_LIBNAME_RELEASE% in %COMPONENT_DIR%
copy .\Release\%LOADER_LIBNAME_RELEASE% %COMPONENT_DIR%

echo Registering TclXPCOM Component Loader...
%REGXPCOM%

if %DEBUG%==0 goto end

echo Installing %LOADER_LIBNAME_DEBUG% in %COMPONENT_DIR_DEBUG%
copy .\Debug\%LOADER_LIBNAME_DEBUG% %COMPONENT_DIR_DEBUG%

echo Registering TclXPCOM Debug Component Loader...
%REGXPCOM_DEBUG%

:end
